/*
 * ! OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["./library","sap/ui/core/Core","sap/ui/core/Control","sap/ui/core/IconPool","sap/ui/layout/form/SimpleForm","sap/ui/layout/VerticalLayout","sap/ui/layout/HorizontalLayout","sap/m/Page","sap/m/Button","sap/m/Bar","sap/m/Title","sap/m/Image","sap/m/Link","sap/m/Text","sap/m/Label","sap/m/HBox","sap/ui/core/Icon","sap/ui/core/Title","sap/ui/core/CustomData","sap/ui/core/library","sap/ui/layout/library","sap/ui/Device","sap/ui/layout/form/ResponsiveGridLayout","./QuickViewPageRenderer","sap/base/security/encodeURL","sap/ui/dom/jquery/Focusable"],function(l,C,a,I,S,V,H,P,B,b,T,c,L,d,e,f,g,h,i,m,n,D,R,Q,o){"use strict";var U=l.URLHelper;var p=n.form.SimpleFormLayout;var q=m.TitleLevel;var r=l.QuickViewGroupElementType;var s=l.ButtonType;var t=C.getLibraryResourceBundle('sap.m');var u=a.extend("sap.m.QuickViewPage",{metadata:{library:"sap.m",properties:{pageId:{type:"string",group:"Misc",defaultValue:""},header:{type:"string",group:"Misc",defaultValue:""},title:{type:"string",group:"Misc",defaultValue:""},titleUrl:{type:"string",group:"Misc",defaultValue:""},crossAppNavCallback:{type:"object",group:"Misc"},description:{type:"string",group:"Misc",defaultValue:""},icon:{type:"string",group:"Misc",defaultValue:""},fallbackIcon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null}},defaultAggregation:"groups",aggregations:{groups:{type:"sap.m.QuickViewGroup",multiple:true,singularName:"group",bindable:"bindable"}}}});u.prototype.init=function(){var G=sap.ushell&&sap.ushell.Container&&sap.ushell.Container.getService;if(G){this.oCrossAppNavigator=G("CrossApplicationNavigation");}};u.prototype.onBeforeRendering=function(){this._destroyPageContent();this._createPageContent();};u.prototype.getPageContent=function(){return this._mPageContent;};u.prototype.setNavContext=function(j){this._mNavContext=j;};u.prototype.getNavContext=function(){return this._mNavContext;};u.prototype.setPageTitleControl=function(j){this._oPageTitle=j;};u.prototype.getPageTitleControl=function(){return this._oPageTitle;};u.prototype._createPage=function(){var j=this._createPageContent();var N=this.getNavContext();var k;if(this._oPage){k=this._oPage;k.destroyContent();k.setCustomHeader(new b());}else{k=this._oPage=new P(N.quickViewId+'-'+this.getPageId(),{customHeader:new b()});k.addEventDelegate({onAfterRendering:this.onAfterRenderingPage},this);}if(this.getHeader()===""&&N.quickView.getPages().length===1&&!D.system.phone){k.setShowHeader(false);k.addStyleClass('sapMQuickViewPageWithoutHeader');}if(j.header){k.addContent(j.header);}k.addContent(j.form);var v=k.getCustomHeader();v.addContentMiddle(new T({text:this.getHeader()}).addStyleClass("sapMQuickViewTitle"));if(N.hasBackButton){v.addContentLeft(new B({type:s.Back,tooltip:t.getText("PAGE_NAVBUTTON_TEXT"),press:function(){if(N.navContainer){N.quickView._setNavOrigin(null);N.navContainer.back();}}}));}if(N.popover&&D.system.phone){v.addContentRight(new B({icon:I.getIconURI("decline"),press:function(){N.popover.close();}}));}k.addStyleClass('sapMQuickViewPage');return k;};u.prototype.onAfterRenderingPage=function(){var j=this.getParent(),k=j instanceof a&&j.isA('sap.m.QuickView');if(k&&!this._oPage.$().firstFocusableDomRef()){this._oPage.$('cont').attr('tabindex',0);}if(this._bItemsChanged){var N=this.getNavContext();if(N){N.quickView._restoreFocus();}this._bItemsChanged=false;}};u.prototype._createPageContent=function(){var F=this._createForm();var j=this._getPageHeaderContent();var k=this.getPageTitleControl();if(j&&k){F.addAriaLabelledBy(k);}this._mPageContent={form:F,header:j};return this._mPageContent;};u.prototype._createForm=function(){var G=this.getAggregation("groups"),F=new S({maxContainerCols:1,editable:false,layout:p.ResponsiveGridLayout});if(G){for(var j=0;j<G.length;j++){if(G[j].getVisible()){this._renderGroup(G[j],F);}}}return F;};u.prototype._getPageHeaderContent=function(){var j,F,k=this.getFallbackIcon(),v=new V(),w=new H(),x=this.getIcon(),y=this.getTitle(),z=this.getDescription(),A=this.getTitleUrl();if(!x&&!y&&!z){return null;}if(x){if(this.getIcon().indexOf("sap-icon")==0){j=this._createIcon(x,!A,y);}else{j=new c({src:x,decorative:false,tooltip:y}).addStyleClass("sapUiIcon sapMQuickViewPageImage");if(I.isIconURI(k)){F=this._createIcon(k,!A,y);F.addStyleClass("sapMQuickViewThumbnail sapMQuickViewPageFallbackIconHidden");j.attachError(this._onImageLoadError.bind(this));w.addContent(F);}}j.addStyleClass("sapMQuickViewThumbnail");if(A){j.attachPress(this._crossApplicationNavigation(this));if(F){F.attachPress(this._crossApplicationNavigation(this));}}w.addContent(j);}var E;if(A){E=new L({text:y,href:A,target:"_blank"});}else if(this.getCrossAppNavCallback()){E=new L({text:y});E.attachPress(this._crossApplicationNavigation(this));}else{E=new T({text:y,level:q.H1});}this.setPageTitleControl(E);var G=new d({text:z});v.addContent(E);v.addContent(G);w.addContent(v);return w;};u.prototype._createIcon=function(j,k,v){return new g({src:j,decorative:k,useIconTooltip:false,tooltip:v});};u.prototype._renderGroup=function(G,F){var E=G.getAggregation("elements");var j,v,w;if(G.getHeading()){F.addContent(new h({text:G.getHeading(),level:q.H2}));}if(!E){return;}var N=this.getNavContext();for(var k=0;k<E.length;k++){j=E[k];if(!j.getVisible()){continue;}w=new e({text:j.getLabel()});var x;if(N){x=N.quickViewId;}v=j._getGroupElementValue(x);F.addContent(w);if(!v){F.addContent(new d({text:""}));continue;}w.setLabelFor(v.getId());if(j.getType()==r.pageLink){v.attachPress(this._attachPressLink(this));}if(j.getType()==r.mobile&&!D.system.desktop){var y=new g({src:I.getIconURI("post"),tooltip:t.getText("QUICKVIEW_SEND_SMS"),decorative:false,customData:[new i({key:"phoneNumber",value:j.getValue()})],press:this._mobilePress});var z=new f({items:[v,y]});F.addContent(z);}else{F.addContent(v);}}};u.prototype._crossApplicationNavigation=function(j){return function(){if(j.getCrossAppNavCallback()&&j.oCrossAppNavigator){var k=j.getCrossAppNavCallback();if(typeof k=="function"){var v=k();var w=j.oCrossAppNavigator.hrefForExternal({target:{semanticObject:v.target.semanticObject,action:v.target.action},params:v.params});U.redirect(w);}}else if(j.getTitleUrl()){window.open(j.getTitleUrl(),"_blank");}};};u.prototype._destroyPageContent=function(){if(!this._mPageContent){return;}if(this._mPageContent.form){this._mPageContent.form.destroy();}if(this._mPageContent.header){this._mPageContent.header.destroy();}this._mPageContent=null;};u.prototype.exit=function(){if(this._oPage){this._oPage.destroy();this._oPage=null;}else{this._destroyPageContent();}this._mNavContext=null;};u.prototype._attachPressLink=function(j){var N=j.getNavContext();return function(E){E.preventDefault();var k=this.getCustomData()[0].getValue();if(N.navContainer&&k){N.quickView._setNavOrigin(this);N.navContainer.to(k);}};};u.prototype._mobilePress=function(){var j="sms://"+o(this.getCustomData()[0].getValue());window.location.replace(j);};u.prototype._updatePage=function(){var N=this.getNavContext();if(N&&N.quickView._bRendered){this._bItemsChanged=true;N.popover.focus();if(N.quickView.indexOfPage(this)==0){N.quickView._clearContainerHeight();}this._createPage();N.popover.$().css('display','block');N.quickView._adjustContainerHeight();N.quickView._restoreFocus();}};["setModel","bindAggregation","setAggregation","insertAggregation","addAggregation","removeAggregation","removeAllAggregation","destroyAggregation"].forEach(function(F){u.prototype["_"+F+"Old"]=u.prototype[F];u.prototype[F]=function(){var j=u.prototype["_"+F+"Old"].apply(this,arguments);this._updatePage();if(["removeAggregation","removeAllAggregation"].indexOf(F)!==-1){return j;}return this;};});u.prototype.setProperty=function(){a.prototype.setProperty.apply(this,arguments);this._updatePage();return this;};u.prototype.getQuickViewBase=function(){var j=this.getParent();if(j&&j.isA("sap.m.QuickViewBase")){return j;}return null;};u.prototype._onImageLoadError=function(E){var F=0,j=this._mPageContent.header.getContent()[F],k=E.getSource(),v=document.activeElement===k.getDomRef();j.removeStyleClass("sapMQuickViewPageFallbackIconHidden");k.addStyleClass("sapMQuickViewPageFailedImage");if(v){j.focus();}};return u;});
