/*!
 * OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['./Core','./Component','sap/base/Log','sap/base/util/extend','sap/base/util/ObjectPath',"sap/base/util/isEmptyObject"],function(C,a,L,e,O,i){"use strict";var b="sap.ui.viewReplacements",c="sap.ui.viewExtensions",d="sap.ui.viewModifications",f="sap.ui.controllerExtensions",g="sap.ui.controllerReplacements";var m={};function h(t,o,k){var s=o&&typeof o==="string"?o:(o&&a.getOwnerIdFor(o));if(s){var l=a.get(s);var p=l&&l.getMetadata().getComponentName();var q=m[p+"::"+s];if(q&&q[t]&&k(q[t])){return false;}else{q=m[p];if(q&&q[t]&&k(q[t])){return false;}}}else{for(p in m){q=m[p];if(q&&q[t]&&k(q[t])){break;}}}}var j={log:function(){if(window.console){window.console.log(m);}},activateForComponent:function(s){L.info("CustomizingConfiguration: activateForComponent('"+s+"')");var F=s+".Component";sap.ui.requireSync(F.replace(/\./g,"/"));var o=O.get(F).getMetadata().getCustomizing();m[s]=o;L.debug("CustomizingConfiguration: customizing configuration for component '"+s+"' loaded: "+JSON.stringify(o));},deactivateForComponent:function(s){if(m[s]){L.info("CustomizingConfiguration: deactivateForComponent('"+s+"')");delete m[s];}},activateForComponentInstance:function(o){L.info("CustomizingConfiguration: activateForComponentInstance('"+o.getId()+"')");var s=o.getMetadata().getComponentName(),k=s+"::"+o.getId(),l=o.getManifest()["sap.ui5"]&&o.getManifest()["sap.ui5"]["extends"]&&o.getManifest()["sap.ui5"]["extends"]["extensions"];m[k]=l;L.debug("CustomizingConfiguration: customizing configuration for component '"+k+"' loaded: "+JSON.stringify(l));},deactivateForComponentInstance:function(o){var s=o.getMetadata().getComponentName(),k=s+"::"+o.getId();if(m[k]){L.info("CustomizingConfiguration: deactivateForComponent('"+k+"')");delete m[k];}},getViewReplacement:function(v,o){var r;h(b,o,function(k){r=k[v];return!!r;});return r;},getViewExtension:function(v,E,o){var r;h(c,o,function(k){r=k[v]&&k[v][E];return!!r;});return r;},getControllerExtension:function(s,o){var r;h(f,o,function(k){r=k[s];return!!r;});return r;},getControllerReplacement:function(s,o){var r;h(g,o,function(k){r=k[s];return!!r;});return r;},getCustomProperties:function(v,s,o){var S;h(d,o,function(k){var l=k[v]&&k[v][s];var u={};var V=false;var p,n;if(l){for(n in l){p=l[n];if(n==="visible"){V=true;u[n]=p;L.info("Customizing: custom value for property '"+n+"' of control '"+s+"' in View '"+v+"' applied: "+p);}else{L.warning("Customizing: custom value for property '"+n+"' of control '"+s+"' in View '"+v+"' ignored: only the 'visible' property can be customized.");}}if(V){S=S||{};e(S,u);}}});return S;},hasCustomProperties:function(v,o){var s={};h(d,o,function(k){if(!!k[v]){s=k[v];}});return!i(s);}};if(sap.ui.getCore().getConfiguration().getDisableCustomizing()){L.info("CustomizingConfiguration: disabling Customizing now");for(var n in j){if(typeof j[n]==="function"){j[n]=function(){};}}}return j;},true);
