/*
 * ! OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/base/Log","sap/ui/core/Element","sap/ui/core/StashedControlSupport","sap/ui/core/util/reflection/JsControlTreeModifier","sap/ui/fl/apply/_internal/changes/FlexCustomData","sap/ui/fl/apply/_internal/changes/Utils","sap/ui/fl/apply/_internal/flexState/changes/DependencyHandler","sap/ui/fl/Utils"],function(L,E,S,J,F,U,D,a){"use strict";var l=new a.FakePromise();function _(C,p){var s=C.getSelector&&C.getSelector();if(!s||(!s.id&&!s.name)){throw Error("No selector in change found or no selector ID.");}var o=p.modifier.bySelector(s,p.appComponent,p.view);if(!o){throw Error("A flexibility change tries to change a nonexistent control.");}var j=C.getDependentControlSelectorList();j.forEach(function(k){var m=p.modifier.bySelector(k,p.appComponent,p.view);if(!m){throw Error("A dependent selector control of the flexibility change is not available.");}});return o;}function b(C,o,m,j,p){var x=f(p);var k=U.getControlIfTemplateAffected(o,C,p);var I=F.hasChangeApplyFinishedCustomData(k.control,o,p.modifier);var n=o.isApplyProcessFinished();if(n&&!I){if(!x){var q=U.checkIfDependencyIsStillValid.bind(null,p.appComponent,p.modifier,m);m=j._oChangePersistence.copyDependenciesFromInitialChangesMap(o,q,p.appComponent);}o.setInitialApplyState();}else if(!n&&I){o.markFinished();}return m;}function c(C,p){var s;if(f(p)&&C.getDefinition().jsOnly){s="Change cannot be applied in XML. Retrying in JS.";}if(s){C.setInitialApplyState();throw Error(s);}}function d(C,m,I,p){if(I instanceof E){m.control=I;}if(m.control){p.modifier.updateAggregation(m.originalControl,C.getContent().boundAggregation);}F.addAppliedCustomData(m.control,C,p,f(p));var r={success:true};C.markFinished(r);return r;}function e(o,C,m,p){var x=f(p);var r={success:false,error:o};var s=C.getId();var j="Change ''{0}'' could not be applied.";var k=o instanceof Error;var n=F.getCustomDataIdentifier(false,k,x);switch(n){case F.notApplicableChangesCustomDataKey:a.formatAndLogMessage("info",[j,o.message],[s]);break;case F.failedChangesCustomDataKeyXml:a.formatAndLogMessage("warning",[j,"Merge error detected while processing the XML tree."],[s],o.stack);break;case F.failedChangesCustomDataKeyJs:a.formatAndLogMessage("error",[j,"Merge error detected while processing the JS control tree."],[s],o.stack);break;}F.addFailedCustomData(m.control,C,p,n);if(x){C.setInitialApplyState();}else{C.markFinished(r);}return r;}function f(p){return p.modifier.targets==="xmlTree";}function g(o,C){var j=C.getDefinition();var s=j.changeType;var t=j.selector.id;var k=j.namespace+j.fileName+"."+j.fileType;var w="A flexibility change could not be applied.";w+="\nThe displayed UI might not be displayed as intedend.";if(o.message){w+="\n   occurred error message: '"+o.message+"'";}w+="\n   type of change: '"+s+"'";w+="\n   LRep location of the change: "+k;w+="\n   id of targeted control: '"+t+"'.";L.warning(w,undefined,"sap.ui.fl.apply._internal.changes.Applier");}function i(C,s){var j=C.mChanges[s]||[];var I=true;var k;j.slice(0).reverse().some(function(o){k=o.getDefinition().changeType;if(k.indexOf("stash")>-1){I=true;return true;}else if(k.indexOf("unstash")>-1){I=false;return true;}});return I;}function h(C,s,o){var H=false;var j=S.getStashedControlIds(s);j.forEach(function(k){if(i(C,k)){var m=D.removeOpenDependentChanges(C,o,k,s);m.forEach(function(n){n._ignoreOnce=true;});H=(m.length>0)?true:H;}});return H;}var A={addPreConditionForInitialChangeApplying:function(p){l=l.then(function(){return p;});},applyChangeOnControl:function(C,o,p){var m=U.getControlIfTemplateAffected(C,o,p);return U.getChangeHandler(C,m,p).then(function(j){c(C,p);return j;}).then(function(j){if(C.hasApplyProcessStarted()){return C.addPromiseForApplyProcessing().then(function(r){C.markFinished();return r;});}else if(!C.isApplyProcessFinished()){return new a.FakePromise().then(function(){C.startApplying();return j.applyChange(C,m.control,p);}).then(function(I){return d(C,m,I,p);}).catch(function(k){return e(k,C,m,p);});}var r={success:true};C.markFinished(r);return r;}).catch(function(j){return{success:false,error:j};});},applyAllChangesForControl:function(G,o,j,C){var m=G();var s=C.getId();var k=m.mChanges[s]||[];var H=h(m,s,o);k.forEach(function(n){if(!n.isApplyProcessFinished()&&!n._ignoreOnce){n.setQueuedForApply();}});l=l.then(function(C,H){var p=[];var s=C.getId();var k=m.mChanges[s]||[];var P={modifier:J,appComponent:o,view:a.getViewForControl(C)};var n;if(m.mControlsWithDependencies[s]){D.removeControlsDependencies(m,s);n=true;}k.forEach(function(q){m=b(C,q,m,j,P);if(q._ignoreOnce){delete q._ignoreOnce;}else if(q.isApplyProcessFinished()){D.resolveDependenciesForChange(m,q.getId(),s);}else if(!m.mDependencies[q.getId()]){p.push(function(){return A.applyChangeOnControl(q,C,P).then(function(){D.resolveDependenciesForChange(m,q.getId(),s);});});}else{var r=A.applyChangeOnControl.bind(A,q,C,P);D.addChangeApplyCallbackToDependency(m,q.getId(),r);}});if(k.length||n||H){return a.execPromiseQueueSequentially(p).then(function(){return D.processDependentQueue(m,o,s);});}}.bind(null,C,H));return l;},applyAllChangesForXMLView:function(p,C){if(!Array.isArray(C)){var s="No list of changes was passed for processing the flexibility on view: "+p.view+".";L.error(s,undefined,"sap.ui.fl.apply._internal.changes.Applier");C=[];}return C.reduce(function(P,o){return P.then(function(){var j=_(o,p);o.setQueuedForApply();b(j,o,undefined,undefined,p);if(!o.isApplyProcessFinished()){return A.applyChangeOnControl(o,j,p);}return{success:true};}).then(function(r){if(!r.success){throw Error(r.error);}}).catch(function(j){g(j,o);});},new a.FakePromise()).then(function(){return p.view;});}};return A;},true);
