/*!
 * OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/mdc/field/ConditionType','sap/ui/model/SimpleType','sap/ui/model/FormatException','sap/ui/model/ParseException','sap/ui/model/ValidateException','sap/base/util/merge','sap/ui/base/SyncPromise'],function(C,S,F,P,V,m,a){"use strict";var b=S.extend("sap.ui.mdc.field.ConditionsType",{constructor:function(f,o){S.apply(this,arguments);this.sName="Conditions";f=_(f);this._oConditionType=new C(f,this.oConstraints);}});b.prototype.destroy=function(){S.prototype.destroy.apply(this,arguments);if(this._oConditionType){this._oConditionType.destroy();this._oConditionType=undefined;}this._bDestroyed=true;};b.prototype.setFormatOptions=function(f){S.prototype.setFormatOptions.apply(this,arguments);f=_(f);if(this._oConditionType){this._oConditionType.setFormatOptions(f);}};function _(f){f=m({},f);if(f.asyncParsing){delete f.asyncParsing;}return f;}b.prototype.setConstraints=function(o){S.prototype.setConstraints.apply(this,arguments);if(this._oConditionType){this._oConditionType.setConstraints(this.oConstraints);}};b.prototype.formatValue=function(f,I){if(f==undefined||f==null||this._bDestroyed){return null;}if(!Array.isArray(f)){throw new F("No valid conditions provided");}var v;if(!I||I==="string"||I==="any"){v="";}else if(I==="float"||I==="int"){v=0;}var M=e.call(this);var s=[];var g=function(o,I){return a.resolve().then(function(){return this._oConditionType.formatValue(o,I);}.bind(this));};for(var i=0;i<f.length;i++){s.push(g.call(this,f[i],I));if(M>0&&i>=M-1){break;}}return a.all(s).then(function(h){return c(h,v);}).unwrap();};function c(f,v){for(var i=0;i<f.length;i++){if(v){v=v+"; "+f[i];}else{v=f[i];}}return v;}b.prototype.parseValue=function(v,i){if(this._bDestroyed){return null;}if(e.call(this)!==1){throw new P("Only one condition supported for parsing");}var o=a.resolve().then(function(){return this._oConditionType.parseValue(v,i);}.bind(this)).then(function(o){return d.call(this,o);}.bind(this)).unwrap();if(o instanceof Promise&&this.oFormatOptions.asyncParsing){this.oFormatOptions.asyncParsing(o);}return o;};function d(o){var I=this.oFormatOptions.isUnit;if(I){var u=o&&o.values[0][1];var f=o&&o.inParameters;var O=o&&o.outParameters;var g=this.oFormatOptions.getConditions();for(var i=0;i<g.length;i++){g[i].values[0][1]=u;g[i].values[0].splice(2);if(g[i].operator==="BT"){g[i].values[1][1]=u;g[i].values[1].splice(2);}if(f||g[i].inParameters){g[i].inParameters=f;}if(O||g[i].outParameters){g[i].outParameters=O;}}if(g.length===0){g.push(o);}return g;}else if(o){return[o];}else{return[];}}b.prototype.validateValue=function(f){if(f===undefined||f===null||this._bDestroyed){return;}if(!Array.isArray(f)){throw new V("No valid conditions provided");}for(var i=0;i<f.length;i++){var o=f[i];this._oConditionType.validateValue(o);}var M=e.call(this);if(f.length===0&&M===1){this._oConditionType.validateValue(null);}};function e(){var M=1;if(this.oFormatOptions.hasOwnProperty("maxConditions")){M=this.oFormatOptions.maxConditions;}return M;}return b;});
