/*!
 * OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['sap/ui/core/Core',"sap/base/util/ObjectPath","sap/base/Log","sap/ui/VersionInfo"],function(c,O,L,V){"use strict";var C={};var a=["sap.chart.Chart","sap.m.ColumnHeaderPopover","sap.m.FacetFilterItem","sap.m.internal.NumericInput","sap.m.IconTabBarSelectList","sap.m.LightBox","sap.m.Menu","sap.m.NotificationListBase","sap.m.NotificationListItem","sap.m.QuickViewBase","sap.m.QuickViewGroup","sap.m.QuickViewGroupElement","sap.m.TabStripItem","sap.m.TimePickerSlider","sap.m.TimePickerSliders","sap.m.UploadCollectionToolbarPlaceholder","sap.m.Wizard","sap.makit.Chart","sap.me.TabContainer","sap.suite.ui.microchart.InteractiveBarChart","sap.suite.ui.microchart.InteractiveDonutChart","sap.tnt.NavigationList","sap.ui.comp.smartform.Group","sap.ui.comp.smartform.GroupElement","sap.ui.comp.valuehelpdialog.ValueHelpDialog","sap.ui.core.mvc.HTMLView","sap.ui.core.mvc.JSONView","sap.ui.core.mvc.JSView","sap.ui.core.mvc.TemplateView","sap.ui.core.mvc.View","sap.ui.core.mvc.XMLView","sap.ui.core.tmpl.Template","sap.ui.core.UIComponent","sap.ui.core.util.Export","sap.ui.documentation.BorrowedList","sap.ui.documentation.LightTable","sap.ui.layout.BlockLayoutRow","sap.ui.layout.form.ResponsiveGridLayoutPanel","sap.ui.layout.form.ResponsiveLayoutPanel","sap.ui.richtexteditor.RichTextEditor","sap.ui.richtexteditor.ToolbarWrapper","sap.ui.rta.AddElementsDialog","sap.ui.rta.ContextMenu","sap.ui.suite.TaskCircle","sap.ui.table.ColumnMenu","sap.ui.unified.Menu","sap.ui.ux3.ActionBar","sap.ui.ux3.ExactList.LB","sap.ui.ux3.NotificationBar","sap.uiext.inbox.composite.InboxTaskTitleControl","sap.uiext.inbox.InboxFormattedTextView","sap.uiext.inbox.InboxTaskDetails","sap.uiext.inbox.InboxToggleTextView","sap.uiext.inbox.SubstitutionRulesManager","sap.uxap.AnchorBar","sap.uxap.BlockBase","sap.uxap.BreadCrumbs","sap.uxap.ObjectPageHeader","sap.uxap.ObjectPageSubSection","sap.viz.ui5.controls.common.BaseControl","sap.viz.ui5.controls.VizRangeSlider","sap.viz.ui5.controls.VizTooltip","sap.viz.ui5.core.BaseChart"];function b(i,r){if(!e(i,r)){return false;}if(a.indexOf(i)>-1){return false;}return true;}var d=["sap.makit.Chart","sap.ui.commons.SearchField","sap.ui.commons.SearchField.CB","sap.ui.commons.SearchFieldCB","sap.ui.commons.Tab","sap.ui.comp.transport.TransportDialog","sap.ui.core.ComponentContainer","sap.ui.core.mvc.HTMLView","sap.ui.core.mvc.JSONView","sap.ui.core.mvc.JSView","sap.ui.core.mvc.TemplateView","sap.ui.core.mvc.View","sap.ui.core.mvc.XMLView","sap.ui.core.XMLComposite","sap.ui.mdc.BaseControl","sap.ui.mdc.odata.v4.microchart.MicroChart","sap.ui.mdc.ValueHelpDialog","sap.ui.mdc.XMLComposite","sap.ui.rta.AddElementsDialog","sap.ui.rta.ContextMenu"];function e(i,r){if(d.indexOf(i)>-1){return false;}if(!r){return false;}var M=r.getMetadata();if(M.isAbstract()){return false;}return true;}C.aKnownOpenUI5Libraries=["sap.f","sap.m","sap.tnt","sap.ui.codeeditor","sap.ui.commons","sap.ui.core","sap.ui.documentation","sap.ui.dt","sap.ui.fl","sap.ui.integration","sap.ui.layout","sap.ui.rta","sap.ui.suite","sap.ui.support","sap.ui.table","sap.ui.unified","sap.ui.ux3","sap.uxap"];C.aKnownRuntimeLayerLibraries=C.aKnownOpenUI5Libraries.concat(["sap.chart","sap.makit","sap.me","sap.ndc","sap.suite.ui.microchart","sap.ui.comp","sap.ui.generic.app","sap.ui.generic.template","sap.ui.mdc","sap.ui.richtexteditor","sap.viz"]);C.isKnownRuntimeLayerLibrary=function(i){return C.aKnownRuntimeLayerLibraries.indexOf(i)>-1;};function n(){}function f(){return true;}function g(){return false;}function t(i){return i.name;}function h(F){F=F||f;return V.load().then(function(i){return i.libraries.map(t).filter(F);}).then(function(i){return Promise.all(i.map(function(r){return c.loadLibrary(r,{async:true}).catch(n);}));}).then(function(){var i=c.getLoadedLibraries();for(var r in i){if(!F(r)){delete i[r];}}return i;});}function l(i){var M=i.replace(/\./g,"/");return new Promise(function(r,u){sap.ui.require([M],function(F){r(F);},function(E){u(new Error("failed to load class "+M+":"+E));});});}function m(i,E,I){if(i){return function(r){return i.indexOf(r)>=0;};}else if(I){return function(r){return E.indexOf(r)<0;};}return function(r){return E.indexOf(r)<0&&(I||C.isKnownRuntimeLayerLibrary(r));};}C.loadLibraries=function(v){if(v==="openui5"){v=C.aKnownOpenUI5Libraries;}else if(v==="sapui5.runtime"){v=C.aKnownRuntimeLayerLibraries;}var F;if(Array.isArray(v)){F=m(v);}else if(typeof v==="function"){F=v;}else if(v==null){F=f;}else{throw new TypeError("unexpected filter "+v);}return h(F);};function j(i,Q){Q.test("Should load at least one library and some controls",function(r){r.expect(2);var u=false;for(var v in i){if(i[v]){if(!u){r.ok(i[v],"Should have loaded at least one library");u=true;}var w=i[v].controls?i[v].controls.length:0;if(w>0){r.ok(w>0,"Should find at least 10 controls in a library");break;}}}});}var s=function(i,r,E,I,u){if(!i||r.length&&r.indexOf(i)<0||E.indexOf(i)>=0){return Promise.resolve(false);}return l(i).then(function(F){var v={name:i,"class":F,canBeInstantiated:e(i,F),canBeRendered:b(i,F)};if(!u&&!v.canBeInstantiated){return false;}if(!I&&!v.canBeRendered){return false;}return v;},g);};var k=function(r,u,E,I,v,w){return new Promise(function(x,y){var z=0;var A=function(i){if(i<r.length){var B=r[i];o(B,u,E,I,v,w).then(function(D){if(D){z++;}A(i+1);});}else{x(z);}};A(0);});};function o(i,r,E,I,u,v){return s(i,r,E,I,u).then(function(w){if(w){v(i,w.class,{canInstantiate:w.canBeInstantiated,canRender:w.canBeRendered});}return new Promise(function(x){setTimeout(function(){x(!!w);},0);});});}C.run=function(i,r){window.setTimeout(function(){_(i,r);},1);};function _(i,r){if(!r){r={};}var D=r.done||n;var u=r.librariesToTest||undefined;var E=r.excludedLibraries||[];var v=r.controlsToTest||[];var w=r.excludedControls||[];var I=(r.includeDistLayer!==undefined)?r.includeDistLayer:false;var x=(r.includeElements!==undefined)?r.includeElements:false;var y=(r.includeNonRenderable!==undefined)?r.includeNonRenderable:true;var z=(r.includeNonInstantiable!==undefined)?r.includeNonInstantiable:false;var Q=r.qunit;if(Q){Q.test("Checking the given QUnit object",function(A){A.ok(true,"The given QUnit should be able to assert");});}else{var A={ok:function(B,T){if(!B){throw new Error(T);}},expect:n};Q={module:n,test:function(B,i){i(A);}};}Q.test("Checking the given options",function(A){A.ok(r.librariesToTest===undefined||Array.isArray(r.librariesToTest),"The given librariesToTest must be undefined or an array, but is: "+r.librariesToTest);A.ok(r.excludedLibraries===undefined||Array.isArray(r.excludedLibraries),"The given excludedLibraries must be undefined or an array, but is: "+r.excludedLibraries);A.ok(r.excludedControls===undefined||Array.isArray(r.excludedControls),"The given excludedControls must be undefined or an array, but is: "+r.excludedControls);A.ok(r.includeDistLayer===undefined||typeof r.includeDistLayer==="boolean","The given includeDistLayer must be undefined or a boolean, but is: "+r.includeDistLayer);A.ok(r.includeElements===undefined||typeof r.includeElements==="boolean","The given includeElements must be undefined or a boolean, but is: "+r.includeElements);A.ok(r.includeNonRenderable===undefined||typeof r.includeNonRenderable==="boolean","The given includeNonRenderable must be undefined or a boolean, but is: "+r.includeNonRenderable);A.ok(r.includeNonInstantiable===undefined||typeof r.includeNonInstantiable==="boolean","The given includeNonInstantiable must be undefined or a boolean, but is: "+r.includeNonInstantiable);A.ok(D===undefined||typeof D==="function","The given done callback must be undefined or a function, but is: "+D);});var F=m(u,E,I);return h(F).then(function(B){j(B,Q);return B;}).then(function(B){return p(B,x,v,w,y,z,i).then(function(R){D({testedControlCount:R[0],testedLibraryCount:R[1]});});});}function p(r,I,u,E,v,w,x){return new Promise(function(y){var z=Object.keys(r),A=0,B=0;var D=function(i){if(i<z.length){var F=z[i];q(r,F,I,u,E,v,w,x).then(function(R){A+=R[0];if(R[1]){B++;}D(i+1);});}else{y([A,B]);}};D(0);});}function q(i,r,I,u,E,v,w,x){return new Promise(function(y){var z=i[r];if(!z){y([0,false]);return;}var A=z.controls;if(I){A=A.concat(z.elements.slice());}k(A,u,E,v,w,x).then(function(B){y([B,true]);});});}return C;},true);
